import 'reflect-metadata';
export declare type ClassType<T> = new (...args: any[]) => T;
export interface Component {
    start(): Promise<any>;
    stop(): Promise<any>;
}
export interface Logger {
    info: (message: string) => void;
    error: (message: string, e?: Error) => void;
}
declare type ConstructorFn<N extends Component, Sys extends System, Deps extends keyof Sys> = (obj: Pick<Sys, Deps>) => N;
export declare class System implements Component {
    static Using<N extends Component, T extends System, K extends (keyof T)>(this: ClassType<T>, dependencies: K[], build: ConstructorFn<N, T, K>): PropertyDecorator;
    start(): Promise<this>;
    stop(): Promise<this>;
    logger: Logger;
    _getComponent(componentName: (keyof this)): Component;
    _getDependencies(componentName: (keyof this) | string): string[];
    _getConstructor(componentName: (keyof this)): ConstructorFn<any, this, any>;
    _setComponent(componentName: (keyof this), comp: any): void;
}
export {};
//# sourceMappingURL=system.d.ts.map