"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.topoSort = void 0;
const hasIncomingEdges = (node) => node.edges.length;
const noIncomingEdges = (node) => !node.edges.length;
const removeEdge = (adjacentVertex, node) => {
    const newNode = Object.assign({}, node);
    newNode.edges = node.edges.filter((vertex) => vertex !== adjacentVertex);
    return newNode;
};
exports.topoSort = (nodes = []) => {
    let noEdges = nodes.filter(noIncomingEdges);
    let withEdges = nodes.filter(hasIncomingEdges);
    const sorted = [];
    while (noEdges.length) {
        const node = noEdges.pop();
        sorted.push(node);
        withEdges = withEdges.map(removeEdge.bind(null, node.id));
        const newNoEdges = withEdges.filter(noIncomingEdges);
        noEdges = noEdges.concat(newNoEdges);
        withEdges = withEdges.filter(hasIncomingEdges);
    }
    return sorted.map((node) => node.id);
};
//# sourceMappingURL=toposort.js.map